#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <time.h>
#include <sys/times.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <ctype.h>
#include <string.h>
#include <limits.h>
#include <unistd.h>
#include <dirent.h>



#define VERSION "aspps.2003.06.04" 
#define EOLN '\n'

struct Atom{
	int			*metalist;
	int			neg;
	int			pos;
	int			cnt;
	char		*txt;
	short		horn;
	short		meta;
	int			hdcnt;
	int			bdycnt;
	int			*hdlst;
	int			*bdylst;
};

struct AtomStk{
	int			neg;
	int			pos;
	int			cnt;
	short		val;
	short		req;
};

struct Rule{
	int 		idx;
	short		horn;
	int 		hdcnt;
	int 		bdycnt;
	int 		*bdyptr;
	int 		*hdptr;
};

struct RuleStk{
	int			sat;
	int 		hdcnt;
	int 		bdycnt;
	double		wgt;
};

struct BackTrack{
	int		atom;
	short	val;
	int		satisfied;
	int		assigned;
	struct	RuleStk *rlst;
	struct	AtomStk *alst;
	struct	BackTrack *up;
	struct	BackTrack *down;
	
};

 

struct BackTrack	*BTtop=NULL;

int		MetaBranch=0;
int		LAH=0;
int		Lah=0;
int		CLS=0;
int		CQ=0;
int		CQlit=0;
int		Restart=0;
int		Local=0;
int		Incomplete=0;
int		Backtrack=0;
int		Debug=0;
int		Answer=0;
int	 	Nvar=0;
int		Outvar=0;
int	 	Nrule=0;
int	 	Nsat=0;
int	 	Nlit=0;
int  	Sat=0;
int  	Tsat=0;
int		Count=0;
int		Cnt=0;
int		Maxlit=0;
int		Minlit=1000000;
int		NonRand=1;
int		Start=0;
int		ReWgt=0;
int		SetAtomCnt=0;
int		Mult=13;
int		Meta=0;

struct Atom		*Atoms;
struct Rule		*Rules;
struct RuleStk	*RList;
struct AtomStk 	*AList;

double	*Weight;
double	*Tmplist;
int 	*SetAtomQueue;
short 	*AtomQueueVal;
short	*PathList;

int     Print=0;
int     Branch=0;
int     Depth=0;
FILE   *Errorfile;
FILE   *fptr;
int		Assigned=0;
int		ShowCnt=0;
char	**ShowAtoms;

